unit RemoteAdoProctol;
{$I ..\Units\RemoteAdo.Inc}
interface
uses Dialogs, Windows, Messages, SysUtils, AdoDb, DB, {$IFDEF IDE_V5_UP}Variants, {$ENDIF}Classes, IniFiles, AdoInt, RemoteAdoUnit, RemoteAdoZLibEx, RemoteAdoPluginUnit;

const
  REMOTEADO_VERSION='4.1.0.0';

  CMD_GET_CONNECTIONNAMES=100; //ѯ
  CMD_GET_PROCEDURENAMES=101; //ѯ
  CMD_GET_PROCEDUREPARAMS=102; //ѯ̲
  CMD_GET_TABLENAMES=103; //ѯ
  CMD_GET_FIELDNAMES=104; //ѯֶ
  CMD_SET_CLIENTNAME=120; //
  CMD_REGISTEDID=130;//עͻID
  CMD_EXECUTE=210; //insert update delete ִ
  CMD_UPDATESQL=211; //UpdateSQL
  CMD_TRANS_BEGIN=220; //ʼ
  CMD_TRANS_COMMIT=221; //ύ
  CMD_TRANS_ROLLBACK=222; //ع
  CMD_DATASET_OPEN=300;
  CMD_DATASET_UPDATE=301;
  CMD_DATASET_REFRESH_RECORD=302;
  //ļ
  CMD_FILE_LIST=400;
  CMD_FILE_INFO=401;
  CMD_FILE_DOWNLOAD=402;
  CMD_FILE_UPLOAD=403;
  CMD_FILE_DELETE=404;
  CMD_FILE_EXIST=405;
  CMD_DIR_DELETE=406;
  //
  CMD_PLUGIN_CALL=500;
  //ȡб
  CMD_GET_ONLINES=600;
  CMD_GET_PEERIP=601;
  //Mobile
  CMD_MOBILE_QUERY=701;
  CMD_MOBILE_EXECUTE=702;
  CMD_MOBILE_PLUGIN=703;
  //
  CMD_RESULT=900; //

  ErrorCode_MissingConnection=10001;
  Error_MissingConnection='Missing Connection.';
  ErrorCode_MetworkError=10002;
  Error_MetworkError='Could not connect to RemoteAdoServer (%s:%d).';
  ErrorCode_ConnectRefused=100021;
  Error_ConnectRefused='Connection be refused from RemoteAdoServer (%s:%d).';
  ErrorCode_ConnectsLimit=100022;
  Error_ConnectsLimit='Connections limit from RemoteAdoServer (%s:%d).';

  ErrorCode_LoginPasswordIncorrect=10003;
  Error_LoginPasswordIncorrect='RemoateAdoServer certification loginpassword incorrect!';
  ErrorCode_TransactionTimeout=10004;
  Error_TransactionTimeout='Transaction was Timeout.';

  ErrorCode_MissingUpdateObject=10005;
  Error_MissingUpdateObject='Missing UpdateObject.';
  ErrorCode_UpdateObjectMissingInsertSQL=100051;
  Error_UpdateObjectMissingInsertSQL='UpdateObject Missing InsertSQL.';
  ErrorCode_UpdateObjectMissingModifySQL=100052;
  Error_UpdateObjectMissingModifySQL='UpdateObject Missing ModifySQL.';
  ErrorCode_UpdateObjectMissingDeleteSQL=100053;
  Error_UpdateObjectMissingDeleteSQL='UpdateObject Missing DeleteSQL.';
  ErrorCode_ConnectionNameIsEmpty=10006;
  Error_ConnectionNameIsEmpty='ConnectionName is empty.';
  ErrorCode_ConnectionNameNoExists=10007;
  Error_ConnectionNameNoExists='ConnectionName ''%s'' not found.';
  ErrorCode_VersionNotMatch=10008;
  Error_VersionNotMatch='VCL Version does not match.';
  ErrorCode_IM_Error=10009;

  ErrorCode_NotInBrowseMode=10020;
  Error_NotInBrowseMode='dataset not in browse mode.';
  ErrorCode_CannotBeInFiltedMode=10021;
  Error_CannotBeInFiltedMode='dataset can''t be in filted mode.';

  ErrorCode_RemoteFileError=10010;
  Error_RemoteFileError='Remote File Error,%s.';
  ErrorCode_RemoteFileNotFound=10011;
  Error_RemoteFileNotFound='Remote File "%s" not found.';
  ErrorCode_LocalFileNotFound=10012;
  Error_LocalFileNotFound='Local File "%s" not found.';

  C_FILE_PRIECE=1024*32;
  C_CRLF=#13#10;

type
  TRemoteCommand=class(TObject)
  private
    FCmdType: Word;
    FCmdCommandText: TMemoryStream;
    FCmdCommandParams: TMemoryStream;
    FCmdConnectionName: AnsiString;
    FCmdResult: Boolean;
    FChangeCount: Integer;
    FLoginPassword: AnsiString;
    FLastError: AnsiString;
    FSystemTables: Boolean;
    FVersion: AnsiString;
    procedure SetCmdCommandText(AText: AnsiString);
    function GetCmdCommandText: AnsiString;
    procedure SetCmdCommandParams(AText: AnsiString);
    function GetCmdCommandParams: AnsiString;
  published
    property CmdType: Word read FCmdType write FCmdType;
    property LoginPassword: AnsiString read FLoginPassword write FLoginPassword;
    property CmdCommandTextStream: TMemoryStream read FCmdCommandText;
    property CmdCommandText: AnsiString read GetCmdCommandText write SetCmdCommandText;
    property CmdCommandParams: AnsiString read GetCmdCommandParams write SetCmdCommandParams;
    property CmdCommandParamsStream: TMemoryStream read FCmdCommandParams;
    property ConnectionName: AnsiString read FCmdConnectionName write FCmdConnectionName;
    property CmdResult: Boolean read FCmdResult write FCmdResult;
    property ChangeCount: Integer read FChangeCount write FChangeCount;
    property LastErrCode: Integer read FChangeCount write FChangeCount;
    property LastError: AnsiString read FLastError write FLastError;
    property SystemTables: Boolean read FSystemTables write FSystemTables;
    property HasPagingData: Boolean read FSystemTables write FSystemTables;
    property RecurseFile: Boolean read FSystemTables write FSystemTables;
    property Version: AnsiString read FVersion;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Clear;

    procedure DataSetSaveComp(Dataset: TCustomRemoteAdoDataSet);
    function DataSetReadComp: TCustomRemoteAdoDataSet;

    procedure DataSetSaveData(Dataset: TCustomRemoteAdoDataSet; xmlFormat: Boolean=False);
    procedure DataSetReadData(Dataset: TCustomRemoteAdoDataSet);

    procedure ReadProcParameters(Parameters: TParameters);
    procedure SaveProcParameters(Parameters: TParameters);

    procedure SavePagingProps(Props: TRemoteAdoPageProps);
    procedure ReadPagingProps(var Props: TRemoteAdoPageProps);

    procedure SaveRemotedAdoUpdateSQLComp(UpdateSQL: TRemoteAdoUpdateSQL);
    function ReadRemotedAdoUpdateSQLComp: TRemoteAdoUpdateSQL;

    procedure SaveToStream(stream: TStream);
    procedure SaveToZipStream(AZipStream: TStream);
    procedure ReadFromStream(stream: TStream);
    procedure ReadFromZipStream(AZipStream: TStream);

    //procedure SaveDataToZipStream()
  end;
  //
  TRemoteAdoFileInfo=packed record
    Size: Int64;
    PieceCount: Integer;
    ID1, ID2: Double;
  end;
  //ļƬ
  TRemoteAdoFilePiece=record
    PiecePos: Integer;
    PieceLen: Integer;
    PieceBuffer: array[0..C_FILE_PRIECE-1] of Byte;
  end;
  //
  TRemoteAdoFileBreakpoint=record
    FileInfo: TRemoteAdoFileInfo;
    LastPos: Integer;
  end;
{$IFNDEF IDE_V5_UP}
  { TInterfaced Persistent }
  IInterface=interface
    ['{00000000-0000-0000-C000-000000000046}']
    function QueryInterface(const IID: TGUID; out Obj): HResult; stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;
  TInterfacedPersistent=class(TPersistent, IInterface)
  private
    FOwnerInterface: IInterface;
  protected
    { IInterface }
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  public
    function QueryInterface(const IID: TGUID; out Obj): HResult; virtual; stdcall;
    procedure AfterConstruction; override;
  end;
{$ENDIF}
  TRemoteAdoPluginParamType=(ptInt, ptInt64, ptString, ptBoolean, ptDouble, ptExtended, ptStream);
  TRemoteAdoPluginParam=class(TInterfacedPersistent, IRemoteAdoPluginParam)
  private
    ParamName: AnsiString;
    ParamType: TRemoteAdoPluginParamType;
    Size: Integer;
    Value: TStringStream;
  public
    constructor Create;
    destructor Destroy; override;
    procedure SetValue(ParamValue: Integer); overload; stdcall;
    procedure SetValue(ParamValue: Int64); overload;
    procedure SetValue(ParamValue: WideString); overload; stdcall;
    procedure SetValue(ParamValue: Boolean); overload; stdcall;
    procedure SetValue(ParamValue: Double); overload; stdcall;
    procedure SetValue(ParamValue: Extended); overload; stdcall;
    procedure SetValue(ParamValue: TStream); overload; stdcall;

    function AsInt(): Integer; stdcall;
    function AsInt64(): Int64; stdcall;
    function AsString(): WideString; stdcall;
    function AsBoolean(): Boolean; stdcall;
    function AsDouble(): Double; stdcall;
    function AsExtended(): Extended; stdcall;
    function AsStream(): TStream; stdcall;
  end;
  TRemoteAdoPluginData=class(TInterfacedPersistent, IRemoteAdoPluginData)
  private
    Params: TStringList;
    function QueryParam(ParamName: WideString): TRemoteAdoPluginParam;
  public
    constructor Create;
    destructor Destroy; override;
    procedure ClearParams; stdcall;
    function AddParam(ParamName: WideString): IRemoteAdoPluginParam; stdcall;
    function GetParam(ParamName: WideString): IRemoteAdoPluginParam; stdcall;
    procedure LoadFromStream(stream: TStream);
    procedure SaveToStream(stream: TStream);
  end;
procedure ZipPacket(SourseStream, DestStream: TStream);
procedure unZipPacket(SourseStream, DestStream: TStream);
function GetFileID(sFileName: AnsiString; var ID1, ID2: Double): Boolean;
function CreateRemoteAdoMemoryStream: TMemoryStream;
procedure ReadParamsFromStream(Params: TParameters; stream: TStream);
procedure WriteParamsToStream(Params: TParameters; stream: TStream);
implementation
type
  TCustomRemoteAdoDataSetA=class(TCustomRemoteAdoDataSet)
  end;

procedure ZipPacket(SourseStream, DestStream: TStream);
var
  unZipStream: TZDecompressionStream;
  UnZipCount: LongWord;
begin
  SourseStream.Seek(0, 0);
  SourseStream.Read(UnZipCount, SizeOf(LongWord));
  unZipStream:=TZDecompressionStream.Create(SourseStream);
  try
    DestStream.Size:=UnZipCount;
    DestStream.CopyFrom(unZipStream, UnZipCount);
  finally
    unZipStream.Free;
    DestStream.Seek(0, 0);
  end;
end;

procedure unZipPacket(SourseStream, DestStream: TStream);
var
  unZipStream: TZDecompressionStream;
  UnZipCount: LongWord;
begin
  SourseStream.Seek(0, 0);
  SourseStream.Position:=0;
  SourseStream.Read(UnZipCount, SizeOf(LongWord));
  unZipStream:=TZDecompressionStream.Create(SourseStream);
  try
    DestStream.Size:=UnZipCount;
    DestStream.Seek(0, 0);
    DestStream.CopyFrom(unZipStream, UnZipCount);
  finally
    unZipStream.Free;
    DestStream.Seek(0, 0);
  end;
end;


procedure WriteVariantToStream(Value: Variant; Stream: TStream; ValueFieldType: TFieldType);
var
  len, IntValue: Integer;
  Int64Value: Int64;
  DoubleValue: Double;
  BCDValue: Currency;
  BooleanValue: Boolean;
  StrValue: AnsiString;
begin
  case ValueFieldType of
    ftWord,ftSmallInt, ftInteger:
      begin
        IntValue := Value;
        Stream.Write(IntValue, 4);
      end;
    ftLargeInt:
      begin
        Int64Value := StrToInt64(VarToStr(Value));
        Stream.Write(Int64Value, 8);
      end;
    ftFloat, ftDateTime:
      begin
        DoubleValue := Value;
        Stream.Write(DoubleValue, 8);
      end;
    ftBCD:
      begin
        BCDValue := Value;
        Stream.Write(BCDValue, 8);
      end;
    ftBoolean:
      begin
        BooleanValue := Value;
        Stream.Write(BooleanValue, 1);
      end;
    ftString, ftWideString:
      begin
        StrValue := VarToStr(Value);
        len := length(StrValue);
        Stream.Write(len, 4);
        Stream.Write(StrValue[1], len);
      end;
  end;
end;

function ReadVariantFromStream(Stream: TStream; ValueFieldType: TFieldType): Variant;
var
  len, IntValue: Integer;
  Int64Value: Int64;
  DoubleValue: Double;
  BCDValue: Currency;
  BooleanValue: Boolean;
  StrValue: AnsiString;
begin
  Result := Null;
  case ValueFieldType of
    ftWord,ftSmallInt, ftInteger:
      begin
        Stream.Read(IntValue, 4);
        Result := IntValue;
      end;
    ftLargeInt:
      begin
        Stream.Read(Int64Value, 8);
        Result := IntToStr(Int64Value);
      end;
    ftFloat, ftDateTime:
      begin
        Stream.Read(DoubleValue, 8);
        Result := DoubleValue;
      end;
    ftBCD:
      begin
        Stream.Read(BCDValue, 8);
        Result := BCDValue;
      end;
    ftBoolean:
      begin
        Stream.Read(BooleanValue, 1);
        Result := BooleanValue;
      end;
    ftString, ftWideString:
      begin
        Stream.Read(len, 4);
        SetLength(StrValue, len);
        Stream.Read(StrValue[1], len);
        Result := StrValue;
        StrValue := Result;
      end;
  end;
end;

procedure WriteParamsToStream(Params: TParameters; stream: TStream);
var
  Count, len, i: Integer;
  ParamType: TDataType;
  ParamDirection: TParameterDirection;
  ParamName, StrValue: AnsiString;
  BinData: Variant;
  DataPtr: Pointer;
  IsVarArray, IsVarNull, IsUnAssigned: Boolean;
begin
  Count:=Params.Count;
  stream.Write(Count, 4);
  for i:=0 to Count-1 do
  begin
    ParamType:=Params[i].DataType;
    stream.Write(ParamType, 1);

    ParamDirection:=Params[i].Direction;
    stream.Write(ParamDirection, 1);

    ParamName:=Params[i].Name;
    len:=length(ParamName);
    stream.Write(len, 4);
    stream.Write(ParamName[1], len);

    IsVarArray:=VarIsArray(Params[i].Value);
    stream.Write(IsVarArray, 1);

    IsVarNull:=VarIsNull(Params[i].Value);
    stream.Write(IsVarNull, 1);

    IsUnAssigned:=VarIsEmpty(Params[i].Value);
    stream.Write(IsUnAssigned, 1);

    if (not IsVarNull)and(not IsUnAssigned) then
    begin
      if IsVarArray then
      begin
        BinData:=Params[i].Value;
        len:=VarArrayHighBound(BinData, 1)+1;
        stream.Write(len, 4);
        if len>-1 then
        begin
          DataPtr:=VarArrayLock(BinData);
          try
            stream.WriteBuffer(DataPtr^, len);
          finally
            VarArrayUnlock(BinData);
          end;
        end;
      end
      else
      begin
        WriteVariantToStream(Params[i].Value, stream, ParamType);
      end;
    end;
  end;
end;

procedure ReadParamsFromStream(Params: TParameters; stream: TStream);
var
  Count, len, i: Integer;
  ParamType: TDataType;
  ParamDirection: TParameterDirection;
  ParamName, StrValue: AnsiString;
  BinData: Variant;
  DataPtr: Pointer;
  IsVarArray, IsVarNull, IsUnAssigned: Boolean;
  Parameter: TParameter;
begin
  stream.Read(Count, 4);
  for i:=0 to Count-1 do
  begin

    stream.Read(ParamType, 1);
    stream.Read(ParamDirection, 1);

    stream.Read(len, 4);
    SetLength(ParamName, len);
    stream.Read(Pointer(ParamName)^, len);

    stream.Read(IsVarArray, 1);
    stream.Read(IsVarNull, 1);
    stream.Read(IsUnAssigned, 1);

    if IsVarNull then
      BinData:=Null
    else if IsUnAssigned then
      BinData:=UnAssigned
    else
    begin
      if IsVarArray then
      begin
        stream.Read(len, 4);
        if len>-1 then
        begin
          BinData:=VarArrayCreate([0, len-1], varByte);
          DataPtr:=VarArrayLock(BinData);
          try
            stream.ReadBuffer(DataPtr^, len);
          finally
            VarArrayUnlock(BinData);
          end;
        end
        else
        begin
          BinData:=VarArrayCreate([0, -1], varByte);
        end;
      end
      else
      begin
        BinData:=ReadVariantFromStream(stream, ParamType);
      end;
    end;
    Params.CreateParameter(ParamName, ParamType, ParamDirection, 0, BinData)
  end;
end;

function GetFileID(sFileName: AnsiString; var ID1, ID2: Double): Boolean;
var
  FFindData: TWin32FindData;
  FFileTime: _FileTime;
  FSystemTime: _SystemTime;
  FDataTime: TDateTime;
  FFindHandle: THandle;
begin
  FFindHandle:=FindFirstFile(Pchar(sFileName), FFindData);
  //ȡļϢ
  Result:=FFindHandle<>INVALID_HANDLE_VALUE;
  if FFindHandle<>INVALID_HANDLE_VALUE then
  begin
    //תFILETIMEʽΪlocalFILETIMEʽ
    FileTimeToLocalFileTime(FFindData.ftCreationTime, FFileTime);
    FileTimeToSystemTime(FFileTime, FSystemTime);
    FDataTime:=SystemTimeToDateTime(FSystemTime);
    ID1:=FDataTime;
    FileTimeToLocalFileTime(FFindData.ftLastWriteTime, FFileTime);
    FileTimeToSystemTime(FFileTime, FSystemTime);
    FDataTime:=SystemTimeToDateTime(FSystemTime);
    ID2:=FDataTime;
  end;
  Windows.FindClose(FFindHandle);
end;
{TRemoteAdoMemoryStream}
resourcestring
  SMemoryStreamError='Out of memory while expanding memory stream';
type
  TRemoteAdoMemoryStream=class(TMemoryStream)
  protected
    function Realloc(var NewCapacity: LongInt): Pointer; override;
  end;

function TRemoteAdoMemoryStream.Realloc(var NewCapacity: LongInt): Pointer;
const
  MemoryDelta=$2000*64;
begin
  if (NewCapacity>0)and(NewCapacity<>Size) then
    NewCapacity:=(NewCapacity+(MemoryDelta-1))and not(MemoryDelta-1);
  Result:=Memory;
  if NewCapacity<>Capacity then
  begin
    if NewCapacity=0 then
    begin
{$IFDEF MSWINDOWS}
      GlobalFreePtr(Memory);
{$ELSE}
      FreeMem(Memory);
{$ENDIF}
      Result:=nil;
    end
    else
    begin
{$IFDEF MSWINDOWS}
      if Capacity=0 then
        Result:=GlobalAllocPtr(HeapAllocFlags, NewCapacity)
      else
        Result:=GlobalReallocPtr(Memory, NewCapacity, HeapAllocFlags);
{$ELSE}
      if Capacity=0 then
        GetMem(Result, NewCapacity)
      else
        ReallocMem(Result, NewCapacity);
{$ENDIF}
      if Result=nil then
        raise EStreamError.CreateRes(@SMemoryStreamError);
    end;
  end;
end;

function CreateRemoteAdoMemoryStream: TMemoryStream;
begin
  Result:=TRemoteAdoMemoryStream.Create;
end;

constructor TRemoteCommand.Create;
begin
  FCmdCommandText:=CreateRemoteAdoMemoryStream;
  FCmdCommandParams:=CreateRemoteAdoMemoryStream;
  Clear;
end;

destructor TRemoteCommand.Destroy;
begin
  FCmdCommandText.Free;
  FCmdCommandParams.Free;
end;

procedure TRemoteCommand.Clear;
begin
  FCmdType:=0;
  FLoginPassword:='';
  FCmdCommandText.Clear;
  FCmdCommandParams.Clear;
  FCmdConnectionName:='';
  FCmdResult:=False;
  FChangeCount:=0;
  FLastError:='';
  FSystemTables:=False;
  FVersion:=REMOTEADO_VERSION;
end;

procedure TRemoteCommand.SetCmdCommandText(AText: AnsiString);
begin
  FCmdCommandText.Clear;
  FCmdCommandText.Write(AText[1], length(AText));
end;

function TRemoteCommand.GetCmdCommandText: AnsiString;
begin
  FCmdCommandText.Position:=0;
  SetLength(Result, FCmdCommandText.Size);
  FCmdCommandText.Read(Result[1], FCmdCommandText.Size);
end;

procedure TRemoteCommand.SetCmdCommandParams(AText: AnsiString);
begin
  FCmdCommandParams.Clear;
  FCmdCommandParams.Write(AText[1], length(AText));
end;

function TRemoteCommand.GetCmdCommandParams: AnsiString;
begin
  FCmdCommandParams.Position:=0;
  SetLength(Result, FCmdCommandParams.Size);
  FCmdCommandParams.Read(Result[1], FCmdCommandParams.Size);
end;

procedure TRemoteCommand.DataSetSaveComp(Dataset: TCustomRemoteAdoDataSet);
begin
  FCmdCommandText.Clear;
  TCustomRemoteAdoDataSetA(Dataset).SaveProps(FCmdCommandText);
end;

function TRemoteCommand.DataSetReadComp(): TCustomRemoteAdoDataSet;
begin
  Result:=TCustomRemoteAdoDataSet.Create(nil);
  TCustomRemoteAdoDataSetA(Result).ReadProps(FCmdCommandText);
end;

procedure TRemoteCommand.DataSetSaveData(Dataset: TCustomRemoteAdoDataSet; xmlFormat: Boolean=False);
begin
  FCmdCommandText.Clear;
  Dataset.SaveToStream(FCmdCommandText, xmlFormat);
end;

procedure TRemoteCommand.DataSetReadData(Dataset: TCustomRemoteAdoDataSet);
begin
  FLastError:=Dataset.LoadFromStream(FCmdCommandText);
end;

procedure TRemoteCommand.SavePagingProps(Props: TRemoteAdoPageProps);
begin
  FCmdCommandText.Write(Props, SizeOf(TRemoteAdoPageProps));
end;
procedure TRemoteCommand.ReadPagingProps(var Props: TRemoteAdoPageProps);
begin
  FCmdCommandText.Read(Props, SizeOf(TRemoteAdoPageProps));
end;
procedure TRemoteCommand.ReadProcParameters;
var
  _StoredProc: TADOStoredProc;
begin
  Parameters.Clear;
  ReadParamsFromStream(Parameters, FCmdCommandParams);
end;

procedure TRemoteCommand.SaveProcParameters;
begin
  WriteParamsToStream(Parameters, FCmdCommandParams);
end;

procedure TRemoteCommand.SaveRemotedAdoUpdateSQLComp(UpdateSQL: TRemoteAdoUpdateSQL);
begin
  FCmdCommandText.Clear;
  FCmdCommandText.WriteComponent(UpdateSQL);
end;

function TRemoteCommand.ReadRemotedAdoUpdateSQLComp: TRemoteAdoUpdateSQL;
begin
  FCmdCommandText.Position:=0;
  Result:=TRemoteAdoUpdateSQL.Create(nil);
  FCmdCommandText.ReadComponent(Result);
end;

procedure TRemoteCommand.SaveToStream(stream: TStream);
var
  len: Integer;
begin
  len:=0;
  stream.Size:=0;

  len:=SizeOf(FCmdType);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FCmdType, len);

  len:=length(FLoginPassword);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FLoginPassword[1], len);

  len:=FCmdCommandText.Size;
  stream.Write(len, SizeOf(Integer));
  stream.Write(FCmdCommandText.Memory^, len);

  len:=FCmdCommandParams.Size;
  stream.Write(len, SizeOf(Integer));
  stream.Write(FCmdCommandParams.Memory^, len);

  len:=length(FCmdConnectionName);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FCmdConnectionName[1], len);

  len:=SizeOf(FCmdResult);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FCmdResult, len);

  len:=SizeOf(FChangeCount);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FChangeCount, len);

  len:=length(FLastError);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FLastError[1], len);

  len:=SizeOf(FSystemTables);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FSystemTables, len);

  FVersion:=REMOTEADO_VERSION;
  len:=length(FVersion);
  stream.Write(len, SizeOf(Integer));
  stream.Write(FVersion[1], len);
end;

procedure TRemoteCommand.SaveToZipStream;
var
  ZlibCompressor: TZCompressionStream;
  ZipCount: LongWord;
  len: Integer;
begin
  ZipCount:=SizeOf(Integer)*10;
  ZipCount:=ZipCount+SizeOf(FCmdType);
  ZipCount:=ZipCount+length(FLoginPassword);
  ZipCount:=ZipCount+FCmdCommandText.Size;
  ZipCount:=ZipCount+FCmdCommandParams.Size;
  ZipCount:=ZipCount+length(FCmdConnectionName);
  ZipCount:=ZipCount+SizeOf(FCmdResult);
  ZipCount:=ZipCount+SizeOf(FChangeCount);
  ZipCount:=ZipCount+length(FLastError);
  ZipCount:=ZipCount+SizeOf(FSystemTables);
  ZipCount:=ZipCount+length(REMOTEADO_VERSION);
  AZipStream.Size:=0;
  AZipStream.Seek(0, 0);
  AZipStream.Write(ZipCount, SizeOf(LongWord));
  ZlibCompressor:=TZCompressionStream.Create(AZipStream, zcFastest);
  try
    len:=SizeOf(FCmdType);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FCmdType, len);

    len:=length(FLoginPassword);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FLoginPassword[1], len);

    len:=FCmdCommandText.Size;
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FCmdCommandText.Memory^, len);

    len:=FCmdCommandParams.Size;
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FCmdCommandParams.Memory^, len);

    len:=length(FCmdConnectionName);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FCmdConnectionName[1], len);

    len:=SizeOf(FCmdResult);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FCmdResult, len);

    len:=SizeOf(FChangeCount);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FChangeCount, len);

    len:=length(FLastError);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FLastError[1], len);

    len:=SizeOf(FSystemTables);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FSystemTables, len);

    FVersion:=REMOTEADO_VERSION;
    len:=length(FVersion);
    ZlibCompressor.Write(len, SizeOf(Integer));
    ZlibCompressor.Write(FVersion[1], len);
  finally
    FreeAndNil(ZlibCompressor);
    AZipStream.Seek(0, 0);
  end;

end;

procedure TRemoteCommand.ReadFromStream(stream: TStream);
var
  len: Integer;
begin
  stream.Position:=0;
  stream.Read(len, SizeOf(Integer));
  stream.Read(FCmdType, len);

  stream.Read(len, SizeOf(Integer));
  SetLength(FLoginPassword, len);
  stream.Read(FLoginPassword[1], len);

  stream.Read(len, SizeOf(Integer));
  FCmdCommandText.Size:=len;
  stream.Read(FCmdCommandText.Memory^, len);

  stream.Read(len, SizeOf(Integer));
  FCmdCommandParams.Size:=len;
  stream.Read(FCmdCommandParams.Memory^, len);

  stream.Read(len, SizeOf(Integer));
  SetLength(FCmdConnectionName, len);
  stream.Read(FCmdConnectionName[1], len);

  stream.Read(len, SizeOf(Integer));
  stream.Read(FCmdResult, len);

  stream.Read(len, SizeOf(Integer));
  stream.Read(FChangeCount, len);

  stream.Read(len, SizeOf(Integer));
  SetLength(FLastError, len);
  stream.Read(FLastError[1], len);

  stream.Read(len, SizeOf(Integer));
  stream.Read(FSystemTables, len);
  if stream.Read(len, SizeOf(Integer))>0 then
  begin
    SetLength(FVersion, len);
    stream.Read(FVersion[1], len);
  end;
end;

procedure TRemoteCommand.ReadFromZipStream(AZipStream: TStream);
var
  unZipStream: TZDecompressionStream;
  UnZipCount: LongWord;
  len: Integer;
begin
  AZipStream.Seek(0, 0);
  AZipStream.Read(UnZipCount, SizeOf(LongWord));
  unZipStream:=TZDecompressionStream.Create(AZipStream);
  try
    unZipStream.Read(len, SizeOf(Integer));
    unZipStream.Read(FCmdType, len);

    unZipStream.Read(len, SizeOf(Integer));
    SetLength(FLoginPassword, len);
    unZipStream.Read(FLoginPassword[1], len);

    unZipStream.Read(len, SizeOf(Integer));
    FCmdCommandText.Size:=len;
    unZipStream.Read(FCmdCommandText.Memory^, len);

    unZipStream.Read(len, SizeOf(Integer));
    FCmdCommandParams.Size:=len;
    unZipStream.Read(FCmdCommandParams.Memory^, len);

    unZipStream.Read(len, SizeOf(Integer));
    SetLength(FCmdConnectionName, len);
    unZipStream.Read(FCmdConnectionName[1], len);

    unZipStream.Read(len, SizeOf(Integer));
    unZipStream.Read(FCmdResult, len);

    unZipStream.Read(len, SizeOf(Integer));
    unZipStream.Read(FChangeCount, len);

    unZipStream.Read(len, SizeOf(Integer));
    SetLength(FLastError, len);
    unZipStream.Read(FLastError[1], len);

    unZipStream.Read(len, SizeOf(Integer));
    unZipStream.Read(FSystemTables, len);

    if unZipStream.Read(len, SizeOf(Integer))>0 then
    begin
      SetLength(FVersion, len);
      unZipStream.Read(FVersion[1], len);
    end;
  finally
    unZipStream.Free;
  end;
end;
{$IFNDEF IDE_V5_UP}
{ TInterfacedPersistent }

procedure TInterfacedPersistent.AfterConstruction;
begin
  inherited;
  if GetOwner<>nil then
    GetOwner.GetInterface(IInterface, FOwnerInterface);
end;

function TInterfacedPersistent._AddRef: Integer;
begin
  if FOwnerInterface<>nil then
    Result:=FOwnerInterface._AddRef
  else
    Result:=-1;
end;

function TInterfacedPersistent._Release: Integer;
begin
  if FOwnerInterface<>nil then
    Result:=FOwnerInterface._Release
  else
    Result:=-1;
end;

function TInterfacedPersistent.QueryInterface(const IID: TGUID;
  out Obj): HResult;
const
  E_NOINTERFACE=HResult($80004002);
begin
  if GetInterface(IID, Obj) then
    Result:=0
  else
    Result:=E_NOINTERFACE;
end;
{$ENDIF}
{ TRemoteAdoPluginParam }

constructor TRemoteAdoPluginParam.Create;
begin
  Value:=TStringStream.Create('');
end;

destructor TRemoteAdoPluginParam.Destroy;
begin
  Value.Free;
  inherited;
end;

procedure TRemoteAdoPluginParam.SetValue(ParamValue: Int64);
begin
  ParamType:=ptInt64;
  Size:=SizeOf(ParamValue);
  Value.Size:=0;
  Value.Write(ParamValue, Size);
end;

procedure TRemoteAdoPluginParam.SetValue(ParamValue: Integer);
begin
  ParamType:=ptInt;
  Size:=SizeOf(ParamValue);
  Value.Size:=0;
  Value.Write(ParamValue, Size);
end;

procedure TRemoteAdoPluginParam.SetValue(ParamValue: Extended);
begin
  ParamType:=ptExtended;
  Size:=SizeOf(ParamValue);
  Value.Size:=0;
  Value.Write(ParamValue, Size);
end;

procedure TRemoteAdoPluginParam.SetValue(ParamValue: Double);
begin
  ParamType:=ptDouble;
  Size:=SizeOf(ParamValue);
  Value.Size:=0;
  Value.Write(ParamValue, Size);
end;

procedure TRemoteAdoPluginParam.SetValue(ParamValue: WideString);
var
  StrValue: AnsiString;
begin
  StrValue:=ParamValue;
  ParamType:=ptString;
  Size:=length(StrValue);
  Value.Size:=0;
  StrValue:=ParamValue;
  Value.Write(StrValue[1], Size);
end;

procedure TRemoteAdoPluginParam.SetValue(ParamValue: Boolean);
begin
  ParamType:=ptBoolean;
  Size:=SizeOf(ParamValue);
  Value.Size:=0;
  Value.Write(ParamValue, Size);
end;

procedure TRemoteAdoPluginParam.SetValue(ParamValue: TStream);
begin
  ParamType:=ptStream;
  Size:=ParamValue.Size;
  Value.Size:=0;
  Value.CopyFrom(ParamValue, 0);
end;

function TRemoteAdoPluginParam.AsBoolean: Boolean;
begin
  Value.Position:=0;
  Value.Read(Result, Size);
end;

function TRemoteAdoPluginParam.AsDouble: Double;
begin
  Value.Position:=0;
  Value.Read(Result, Size);
end;

function TRemoteAdoPluginParam.AsExtended: Extended;
begin
  Value.Position:=0;
  Value.Read(Result, Size);
end;

function TRemoteAdoPluginParam.AsInt: Integer;
begin
  Value.Position:=0;
  Value.Read(Result, Size);
end;

function TRemoteAdoPluginParam.AsInt64: Int64;
begin
  Value.Position:=0;
  Value.Read(Result, Size);
end;

function TRemoteAdoPluginParam.AsString: WideString;
var
  StrValue: AnsiString;
begin
  Value.Position:=0;
  SetLength(StrValue, Size);
  Value.Read(StrValue[1], Size);
  Result:=StrValue;
end;

function TRemoteAdoPluginParam.AsStream: TStream;
begin
  Value.Position:=0;
  Result:=Value;
end;

{ TRemoteAdoPluginData }

constructor TRemoteAdoPluginData.Create;
begin
  inherited;
  Params:=TStringList.Create;
end;

destructor TRemoteAdoPluginData.Destroy;
begin
  ClearParams;
  Params.Free;
  inherited;
end;

function TRemoteAdoPluginData.AddParam(
  ParamName: WideString): IRemoteAdoPluginParam;
var
  Param: TRemoteAdoPluginParam;
begin
  Param:=QueryParam(ParamName);
  if Param=nil then
  begin
    Param:=TRemoteAdoPluginParam.Create;
    Param.ParamName:=ParamName;
    Params.AddObject(ParamName, Param);
  end;
  Result:=Param;
end;

function TRemoteAdoPluginData.GetParam(
  ParamName: WideString): IRemoteAdoPluginParam;
begin
  Result:=QueryParam(ParamName);
end;

procedure TRemoteAdoPluginData.LoadFromStream(stream: TStream);
var
  i, Count, len: Integer;
  Param: TRemoteAdoPluginParam;
begin
  stream.Position:=0;
  stream.Read(Count, SizeOf(Count));
  for i:=0 to Count-1 do
  begin
    Param:=TRemoteAdoPluginParam.Create;
    stream.Read(len, SizeOf(len));
    SetLength(Param.ParamName, len);
    stream.Read(Param.ParamName[1], len);

    stream.Read(Param.ParamType, SizeOf(Param.ParamType));
    stream.Read(Param.Size, SizeOf(Param.Size));
    Param.Value.Size:=Param.Size;
    Param.Value.Position:=0;
    if Param.Size>0 then
      Param.Value.CopyFrom(stream, Param.Size);
    Params.AddObject(Param.ParamName, Param);
  end;
end;

procedure TRemoteAdoPluginData.SaveToStream(stream: TStream);
var
  i, len: Integer;
  Param: TRemoteAdoPluginParam;
begin
  len:=Params.Count;
  stream.Write(len, SizeOf(len));
  for i:=0 to Params.Count-1 do
  begin
    Param:=TRemoteAdoPluginParam(Params.Objects[i]);

    len:=length(Param.ParamName);
    stream.Write(len, SizeOf(len));
    stream.Write(Param.ParamName[1], len);

    stream.Write(Param.ParamType, SizeOf(Param.ParamType));
    len:=Param.Value.Size;
    stream.Write(len, SizeOf(len));
    stream.CopyFrom(Param.Value, 0);
  end;
end;

function TRemoteAdoPluginData.QueryParam(
  ParamName: WideString): TRemoteAdoPluginParam;
var
  index: Integer;
  St: AnsiString;
begin
  Result:=nil;
  index:=Params.IndexOf(ParamName);
  if (index>-1) then
    Result:=TRemoteAdoPluginParam(Params.Objects[index]);
end;

procedure TRemoteAdoPluginData.ClearParams;
var
  i: Integer;
begin
  for i:=0 to Params.Count-1 do
  begin
    TRemoteAdoPluginParam(Params.Objects[i]).Free;
  end;
  Params.Clear;
end;


end.

