unit RemoteAdoPluginUnit;
{******************************************************************}
{                                                                  }
{         RemoteAdoԶ̷òӿڵԪRemoteAdoPluginUnit.pas }
{                                                                  }
{         Ʒҳ http://www.remoteado.cn                         }
{                                                                  }
{         ֧ ideation_shang@126.com                          }
{                                                                  }
{         Ȩ (C) 2007-2011 RemoteAdoаȨ           }
{******************************************************************}
{***********޸ıԪ,ܻɲʶ**************}
{$I RemoteAdo.Inc}
interface
uses
  {$IFNDEF IDE_V5_UP}Windows,{$ENDIF}Classes;

type
  IRemoteAdoPluginParam=interface
    ['{BD41B2DD-FDA1-43F5-BDC8-CC5E9AED13A2}']
    procedure SetValue(ParamValue: Integer); overload; stdcall;
    procedure SetValue(ParamValue: Int64); overload;
    procedure SetValue(ParamValue: WideString); overload; stdcall;
    procedure SetValue(ParamValue: Boolean); overload; stdcall;
    procedure SetValue(ParamValue: Double); overload; stdcall;
    procedure SetValue(ParamValue: Extended); overload; stdcall;
    procedure SetValue(ParamValue: TStream); overload; stdcall;

    function AsInt(): Integer; stdcall;
    function AsInt64(): Int64; stdcall;
    function AsString(): WideString; stdcall;
    function AsBoolean(): Boolean; stdcall;
    function AsDouble(): Double; stdcall;
    function AsExtended(): Extended; stdcall;
    function AsStream(): TStream; stdcall;
    
  end;
  IRemoteAdoPluginData=interface
    ['{8BA9DD91-448F-4A3F-9872-665F489834F7}']
    procedure ClearParams;stdcall;
    function AddParam(ParamName:WideString):IRemoteAdoPluginParam;stdcall;
    function GetParam(ParamName:WideString):IRemoteAdoPluginParam;stdcall;
  end;

  IRemoteAdoPlugin=interface
    ['{58DA2C87-8356-4795-B393-FA246AD85A54}']
    function GetDescription: WideString; stdcall;
    function GetName: WideString; stdcall;
    function GetVerstion: WideString; stdcall;
    procedure OnExecute(ARequest, AResponse: IRemoteAdoPluginData); stdcall;
  end;
  TRemoteAdoPluginObject=class(TObject)
  private
    FHandle: THandle;
    FPlugin: IRemoteAdoPlugin;
  public
    property Handle: THandle read FHandle write FHandle;
    property Plugin: IRemoteAdoPlugin read FPlugin write FPlugin;
  end;
  TRemoteAdoPlugin=class(TInterfacedObject, IRemoteAdoPlugin)
  private
    FName: WideString;
    FDescription: WideString;
    FVersion: WideString;
  public
    procedure AfterConstruction; override;
    destructor Destroy; override;
    function GetDescription: WideString; stdcall;
    function GetName: WideString; stdcall;
    function GetVerstion: WideString; stdcall;
    procedure OnExecute(ARequest, AResponse: IRemoteAdoPluginData); virtual; stdcall;
    procedure OnLoad; virtual;
    procedure OnUnload; virtual;
    property Name: WideString read FName write FName;
    property Description: WideString read FDescription write FDescription;
    property Version: WideString read FVersion write FVersion;
  end;

function RegisterPlugin(): IRemoteAdoPlugin; stdcall;
var
  PlugInClass: TClass;

implementation

function RegisterPlugin(): IRemoteAdoPlugin; stdcall;
begin
  Result:=TRemoteAdoPlugin(PlugInClass.Create);
end;
{ TRemoteAdoPlugin }

procedure TRemoteAdoPlugin.OnExecute(ARequest, AResponse: IRemoteAdoPluginData);
begin

end;

function TRemoteAdoPlugin.GetName: WideString;
begin
  Result:=FName;
end;

function TRemoteAdoPlugin.GetDescription: WideString;
begin
  Result:=FDescription;
end;

function TRemoteAdoPlugin.GetVerstion: WideString;
begin
  Result:=FVersion;
end;


procedure TRemoteAdoPlugin.OnLoad;
begin
  //
end;

procedure TRemoteAdoPlugin.OnUnload;
begin
  //
end;

procedure TRemoteAdoPlugin.AfterConstruction;
begin
  inherited;
  OnLoad;
end;

destructor TRemoteAdoPlugin.Destroy;
begin
  OnUnload;
  inherited;
end;
end.

