unit RemoteAdoSQLEditorUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, DB, ADODB, RemoteAdoUnit, ValEdit;

type
  TRemoteAdoSQLEditorForm = class(TForm)
    MemoSQL: TMemo;
    LabelSQL: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    DataSource1: TDataSource;
    DBGrid: TDBGrid;
    ButtonExecute: TButton;
    Label1: TLabel;
    ButtonOpen: TButton;
    LabelRows: TLabel;
    RemoteAdoQuery: TRemoteAdoQuery;
    procedure ButtonExecuteClick(Sender: TObject);
    procedure ButtonOpenClick(Sender: TObject);
  private
    { Private declarations }    
    procedure ErrorMessage(msg:string);
  public
    { Public declarations }
  end;

var
  RemoteAdoSQLEditorForm: TRemoteAdoSQLEditorForm;

implementation

{$R *.dfm}

procedure TRemoteAdoSQLEditorForm.ButtonExecuteClick(Sender: TObject);
var
   FRowsAffected:Integer;
begin
  RemoteAdoQuery.Close;
  try
    try
    RemoteAdoQuery.DisableControls;
    RemoteAdoQuery.SQL.Text:=MemoSQL.Lines.Text;
    FRowsAffected:=RemoteAdoQuery.ExecSQL;
    Application.MessageBox(PChar(Format('%d rows affected.',[FRowsAffected])),'Success',MB_OK);    
    except
      on E:Exception do
      begin
         ErrorMessage(e.Message);
      end;
    end;
  finally
    RemoteAdoQuery.EnableControls;
  end;

end;

procedure TRemoteAdoSQLEditorForm.ButtonOpenClick(Sender: TObject);
begin
  RemoteAdoQuery.Close;
  try
    try
    RemoteAdoQuery.DisableControls;
    RemoteAdoQuery.SQL.Text:=MemoSQL.Lines.Text;
    RemoteAdoQuery.Open;
    LabelRows.Caption:=IntToStr(RemoteAdoQuery.RecordCount)+' Rows.';    
    except
      on E:Exception do
      begin
         ErrorMessage(e.Message);
      end;
    end;
  finally
    RemoteAdoQuery.EnableControls;
  end;
end;

procedure TRemoteAdoSQLEditorForm.ErrorMessage(msg: string);
begin
  msg:=StringReplace(msg,RemoteAdoQuery.Name+':','',[]);
  Application.MessageBox(PChar(msg),'Error',MB_OK+MB_ICONERROR);
end;

end.
